<template>
  <div v-if="classifications === null">Waiting...</div>
  <apexchart
    v-else
    :options="chartOptions"
    :series="series"
    type="bar"
    :height="cheight"
    class="w-full"
  />
</template>

<script>
import { mapState, mapActions } from "vuex";

function status(result) {
  let suc = result.classification.SUCCESS;
  let ins = result.classification.UNSATISFACTORY;

  if (suc > ins) {
    return {
      prediction: "SATISFACTORY",
      confidence: 100 * (suc / (suc + ins))
    };
  } else {
    return {
      prediction: "UNSATISFACTORY",
      confidence: 100 * (ins / (suc + ins))
    };
  }
}

export default {
  computed: {
    ...mapState(["classifications", "selectedClassification"]),

    cheight() {
      return this.classifications.length * 45 + 100;
    },

    chartOptions() {
      const calculatedColors = this.classifications.map(status).map(s => {
        if (s.prediction === "SATISFACTORY") return "#00acac";
        if (s.prediction === "UNSATISFACTORY") return "#ff690a";
      });

      return {
        chart: {
          id: "patient_classification",
          type: "bar",
          events: {
            dataPointSelection: (event, context, config) => {
              this.changeSelectedClassification(config.dataPointIndex);
            }
          }
        },
        plotOptions: {
          bar: {
            horizontal: true
          }
        },
        fill: {
          colors: [
            (function() {
              let i = 0;
              return function() {
                const color = calculatedColors[i];
                i = (i + 1) % calculatedColors.length;
                return color;
              };
            })()
          ]
        },
        dataLabels: {
          enabled: true,
          textAnchor: "middle",
          formatter: (value, options) => {
            return status(this.classifications[options.dataPointIndex])
              .prediction;
          }
        },
        xaxis: {
          categories: this.classifications.map(c =>
            c.name.replace(".json", "")
          ),

          tickAmount: 10,
          min: 0,
          max: 100,
          labels: {
            formatter(value) {
              return value + "%";
            }
          }
        },
        tooltip: {
          y: {
            formatter(value) {
              return value.toFixed(2) + "%";
            }
          }
        }
      };
    },
    series() {
      return [
        {
          name: "Patient classification",
          data: this.classifications.map(status).map(s => s.confidence)
        }
      ];
    }
  },
  methods: {
    ...mapActions(["changeSelectedClassification"])
  }
};
</script>
